/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
/**
 * @author Generated on 02/26/2019 16:32:45+0100 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige3.core::vo::administration::program::MonLocProgVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige3.core.vo.administration.program;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Liste des lieux surveillés par un programme.
 */
public class MonLocProgVO
    implements Serializable, Comparable<MonLocProgVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = 1050593859182152129L;

    // Class attributes
    /** TODO: Model Documentation for attribute monLocProgId */
    protected Integer monLocProgId;
    /**
     * Date de modification de l'objet, mise à jour par le système
     */
    protected Timestamp updateDt;
    /**
     * Identifiant interne du lieu de surveillance
     */
    protected Integer monLocId;
    /** TODO: Model Documentation for attribute progCd */
    protected String progCd;

    // Class associationEnds
    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     */
    protected ProgramVO programVO;

    /** Default Constructor with no properties */
    public MonLocProgVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param monLocProgIdIn Integer
     * @param monLocIdIn Integer Identifiant interne du lieu de surveillance
     * @param progCdIn String
     * @param programVOIn ProgramVO Activités à l'origine de la collecte d'un ensemble cohérent de données.
     */
    public MonLocProgVO(final Integer monLocProgIdIn, final Integer monLocIdIn, final String progCdIn, final ProgramVO programVOIn)
    {
        this.monLocProgId = monLocProgIdIn;
        this.monLocId = monLocIdIn;
        this.progCd = progCdIn;
        this.programVO = programVOIn;
    }

    /**
     * Constructor with all properties
     * @param monLocProgIdIn Integer
     * @param updateDtIn Timestamp
     * @param monLocIdIn Integer
     * @param progCdIn String
     * @param programVOIn ProgramVO
     */
    public MonLocProgVO(final Integer monLocProgIdIn, final Timestamp updateDtIn, final Integer monLocIdIn, final String progCdIn, final ProgramVO programVOIn)
    {
        this.monLocProgId = monLocProgIdIn;
        this.updateDt = updateDtIn;
        this.monLocId = monLocIdIn;
        this.progCd = progCdIn;
        this.programVO = programVOIn;
    }

    /**
     * Copies constructor from other MonLocProgVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public MonLocProgVO(final MonLocProgVO otherBean)
    {
        this.monLocProgId = otherBean.getMonLocProgId();
        this.updateDt = otherBean.getUpdateDt();
        this.monLocId = otherBean.getMonLocId();
        this.progCd = otherBean.getProgCd();
        this.programVO = otherBean.getProgramVO();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final MonLocProgVO otherBean)
    {
        if (null != otherBean)
        {
            this.setMonLocProgId(otherBean.getMonLocProgId());
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setMonLocId(otherBean.getMonLocId());
            this.setProgCd(otherBean.getProgCd());
            this.setProgramVO(otherBean.getProgramVO());
        }
    }

    /**
     * TODO: Model Documentation for attribute monLocProgId
     * Get the monLocProgId Attribute
     * @return monLocProgId Integer
     */
    public Integer getMonLocProgId()
    {
        return this.monLocProgId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setMonLocProgId(final Integer value)
    {
        this.monLocProgId = value;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * Identifiant interne du lieu de surveillance
     * Get the monLocId Attribute
     * @return monLocId Integer
     */
    public Integer getMonLocId()
    {
        return this.monLocId;
    }

    /**
     * Identifiant interne du lieu de surveillance
     * @param value Integer
     */
    public void setMonLocId(final Integer value)
    {
        this.monLocId = value;
    }

    /**
     * TODO: Model Documentation for attribute progCd
     * Get the progCd Attribute
     * @return progCd String
     */
    public String getProgCd()
    {
        return this.progCd;
    }

    /**
     * 
     * @param value String
     */
    public void setProgCd(final String value)
    {
        this.progCd = value;
    }

    /**
     * Activités à l'origine de la collecte d'un ensemble cohérent de données.
     * Get the programVO Association
     * @return this.programVO ProgramVO
     */
    public ProgramVO getProgramVO()
    {
        return this.programVO;
    }

    /**
     * Sets the programVO
     * @param value ProgramVO
     */
    public void setProgramVO(ProgramVO value)
    {
        this.programVO = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        MonLocProgVO rhs = (MonLocProgVO) object;
        return new EqualsBuilder()
            .append(this.getMonLocProgId(), rhs.getMonLocProgId())
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getMonLocId(), rhs.getMonLocId())
            .append(this.getProgCd(), rhs.getProgCd())
            .append(this.getProgramVO(), rhs.getProgramVO())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final MonLocProgVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getMonLocProgId(), object.getMonLocProgId())
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getMonLocId(), object.getMonLocId())
            .append(this.getProgCd(), object.getProgCd())
            .append(this.getProgramVO(), object.getProgramVO())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getMonLocProgId())
            .append(this.getUpdateDt())
            .append(this.getMonLocId())
            .append(this.getProgCd())
            .append(this.getProgramVO())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("monLocProgId", this.getMonLocProgId())
            .append("updateDt", this.getUpdateDt())
            .append("monLocId", this.getMonLocId())
            .append("progCd", this.getProgCd())
            .append("programVO", this.getProgramVO())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // MonLocProgVO value-object java merge-point
}