/*
  * #%L
  * Quadrige3 Core
  * %%
  * Copyright (C) 2017 Ifremer
  * %%
  * This program is free software: you can redistribute it and/or modify
  * it under the terms of the GNU Affero General Public License as published by
  * the Free Software Foundation, either version 3 of the License, or
  * (at your option) any later version.
  *
  * This program is distributed in the hope that it will be useful,
  * but WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  * GNU General Public License for more details.
  *
  * You should have received a copy of the GNU Affero General Public License
  * along with this program.  If not, see <http://www.gnu.org/licenses/>.
  * #L%
  */
//
/**
 * @author Generated on 02/26/2019 16:32:45+0100 Do not modify by hand!
 *
 * TEMPLATE:     ValueObject.vsl in andromda-java-cartridge.
 * MODEL CLASS:  Données::fr.ifremer.quadrige3.core::vo::administration::strategy::AppliedStrategyVO
 * STEREOTYPE:   ValueObject
 */
package fr.ifremer.quadrige3.core.vo.administration.strategy;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.Arrays;
import org.apache.commons.lang3.builder.CompareToBuilder;
import org.apache.commons.lang3.builder.EqualsBuilder;
import org.apache.commons.lang3.builder.HashCodeBuilder;
import org.apache.commons.lang3.builder.ToStringBuilder;

/**
 * Identifie les conditions d'application locale de la stratégie pour une période donnée.
 */
public class AppliedStrategyVO
    implements Serializable, Comparable<AppliedStrategyVO>
{
    /** The serial version UID of this class. Needed for serialization. */
    private static final long serialVersionUID = 7141714624259538612L;

    // Class attributes
    /** TODO: Model Documentation for attribute appliedStratId */
    protected Integer appliedStratId;
    /**
     * Date de modification de l'objet, mise à jour par le système
     */
    protected Timestamp updateDt;
    /** TODO: Model Documentation for attribute freqCd */
    protected String freqCd;
    /** TODO: Model Documentation for attribute monLocId */
    protected Integer monLocId;
    /** TODO: Model Documentation for attribute depId */
    protected Integer depId;
    /** TODO: Model Documentation for attribute taxonGroupId */
    protected Integer taxonGroupId;
    /** TODO: Model Documentation for attribute refTaxonId */
    protected Integer refTaxonId;
    /** TODO: Model Documentation for attribute stratId */
    protected Integer stratId;

    // Class associationEnds
    /**
     * PMSF associés à une stratégie pour un lieu données.
     */
    protected PmfmAppliedStrategyVO[] pmfmAppliedStrategyVOs;

    /**
     * Liste des périodes durant lesquels une stratégie est appliquée en un lieu.
     */
    protected AppliedPeriodVO[] appliedPeriodVOs;

    /**
     * Définie les paramètres à mesurer dans un programme particulier.
     */
    protected StrategyVO strategyVO;

    /** Default Constructor with no properties */
    public AppliedStrategyVO()
    {
        // Documented empty block - avoid compiler warning - no super constructor
    }

    /**
     * Constructor taking only required properties
     * @param appliedStratIdIn Integer
     * @param stratIdIn Integer
     * @param strategyVOIn StrategyVO Définie les paramètres à mesurer dans un programme particulier.
     */
    public AppliedStrategyVO(final Integer appliedStratIdIn, final Integer stratIdIn, final StrategyVO strategyVOIn)
    {
        this.appliedStratId = appliedStratIdIn;
        this.stratId = stratIdIn;
        this.strategyVO = strategyVOIn;
    }

    /**
     * Constructor with all properties
     * @param appliedStratIdIn Integer
     * @param updateDtIn Timestamp
     * @param freqCdIn String
     * @param monLocIdIn Integer
     * @param depIdIn Integer
     * @param taxonGroupIdIn Integer
     * @param refTaxonIdIn Integer
     * @param stratIdIn Integer
     * @param pmfmAppliedStrategyVOsIn PmfmAppliedStrategyVO[]
     * @param appliedPeriodVOsIn AppliedPeriodVO[]
     * @param strategyVOIn StrategyVO
     */
    public AppliedStrategyVO(final Integer appliedStratIdIn, final Timestamp updateDtIn, final String freqCdIn, final Integer monLocIdIn, final Integer depIdIn, final Integer taxonGroupIdIn, final Integer refTaxonIdIn, final Integer stratIdIn, final PmfmAppliedStrategyVO[] pmfmAppliedStrategyVOsIn, final AppliedPeriodVO[] appliedPeriodVOsIn, final StrategyVO strategyVOIn)
    {
        this.appliedStratId = appliedStratIdIn;
        this.updateDt = updateDtIn;
        this.freqCd = freqCdIn;
        this.monLocId = monLocIdIn;
        this.depId = depIdIn;
        this.taxonGroupId = taxonGroupIdIn;
        this.refTaxonId = refTaxonIdIn;
        this.stratId = stratIdIn;
        this.pmfmAppliedStrategyVOs = pmfmAppliedStrategyVOsIn;
        this.appliedPeriodVOs = appliedPeriodVOsIn;
        this.strategyVO = strategyVOIn;
    }

    /**
     * Copies constructor from other AppliedStrategyVO
     *
     * @param otherBean Cannot be <code>null</code>
     * @throws NullPointerException if the argument is <code>null</code>
     */
    public AppliedStrategyVO(final AppliedStrategyVO otherBean)
    {
        this.appliedStratId = otherBean.getAppliedStratId();
        this.updateDt = otherBean.getUpdateDt();
        this.freqCd = otherBean.getFreqCd();
        this.monLocId = otherBean.getMonLocId();
        this.depId = otherBean.getDepId();
        this.taxonGroupId = otherBean.getTaxonGroupId();
        this.refTaxonId = otherBean.getRefTaxonId();
        this.stratId = otherBean.getStratId();
        this.pmfmAppliedStrategyVOs = otherBean.getPmfmAppliedStrategyVOs();
        this.appliedPeriodVOs = otherBean.getAppliedPeriodVOs();
        this.strategyVO = otherBean.getStrategyVO();
    }

    /**
     * Copies all properties from the argument value object into this value object.
     * @param otherBean Cannot be <code>null</code>
     */
    public void copy(final AppliedStrategyVO otherBean)
    {
        if (null != otherBean)
        {
            this.setAppliedStratId(otherBean.getAppliedStratId());
            this.setUpdateDt(otherBean.getUpdateDt());
            this.setFreqCd(otherBean.getFreqCd());
            this.setMonLocId(otherBean.getMonLocId());
            this.setDepId(otherBean.getDepId());
            this.setTaxonGroupId(otherBean.getTaxonGroupId());
            this.setRefTaxonId(otherBean.getRefTaxonId());
            this.setStratId(otherBean.getStratId());
            this.setPmfmAppliedStrategyVOs(otherBean.getPmfmAppliedStrategyVOs());
            this.setAppliedPeriodVOs(otherBean.getAppliedPeriodVOs());
            this.setStrategyVO(otherBean.getStrategyVO());
        }
    }

    /**
     * TODO: Model Documentation for attribute appliedStratId
     * Get the appliedStratId Attribute
     * @return appliedStratId Integer
     */
    public Integer getAppliedStratId()
    {
        return this.appliedStratId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setAppliedStratId(final Integer value)
    {
        this.appliedStratId = value;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * Get the updateDt Attribute
     * @return updateDt Timestamp
     */
    public Timestamp getUpdateDt()
    {
        return this.updateDt;
    }

    /**
     * Date de modification de l'objet, mise à jour par le système
     * @param value Timestamp
     */
    public void setUpdateDt(final Timestamp value)
    {
        this.updateDt = value;
    }

    /**
     * TODO: Model Documentation for attribute freqCd
     * Get the freqCd Attribute
     * @return freqCd String
     */
    public String getFreqCd()
    {
        return this.freqCd;
    }

    /**
     * 
     * @param value String
     */
    public void setFreqCd(final String value)
    {
        this.freqCd = value;
    }

    /**
     * TODO: Model Documentation for attribute monLocId
     * Get the monLocId Attribute
     * @return monLocId Integer
     */
    public Integer getMonLocId()
    {
        return this.monLocId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setMonLocId(final Integer value)
    {
        this.monLocId = value;
    }

    /**
     * TODO: Model Documentation for attribute depId
     * Get the depId Attribute
     * @return depId Integer
     */
    public Integer getDepId()
    {
        return this.depId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setDepId(final Integer value)
    {
        this.depId = value;
    }

    /**
     * TODO: Model Documentation for attribute taxonGroupId
     * Get the taxonGroupId Attribute
     * @return taxonGroupId Integer
     */
    public Integer getTaxonGroupId()
    {
        return this.taxonGroupId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setTaxonGroupId(final Integer value)
    {
        this.taxonGroupId = value;
    }

    /**
     * TODO: Model Documentation for attribute refTaxonId
     * Get the refTaxonId Attribute
     * @return refTaxonId Integer
     */
    public Integer getRefTaxonId()
    {
        return this.refTaxonId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setRefTaxonId(final Integer value)
    {
        this.refTaxonId = value;
    }

    /**
     * TODO: Model Documentation for attribute stratId
     * Get the stratId Attribute
     * @return stratId Integer
     */
    public Integer getStratId()
    {
        return this.stratId;
    }

    /**
     * 
     * @param value Integer
     */
    public void setStratId(final Integer value)
    {
        this.stratId = value;
    }

    /**
     * PMSF associés à une stratégie pour un lieu données.
     * Get the pmfmAppliedStrategyVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.pmfmAppliedStrategyVOs PmfmAppliedStrategyVO[]
     */
    public PmfmAppliedStrategyVO[] getPmfmAppliedStrategyVOs()
    {
        return this.pmfmAppliedStrategyVOs;
    }

    /**
     * Sets the pmfmAppliedStrategyVOs
     * @param value PmfmAppliedStrategyVO[]
     */
    public void setPmfmAppliedStrategyVOs(PmfmAppliedStrategyVO[] value)
    {
        this.pmfmAppliedStrategyVOs = value;
    }

    /**
     * Liste des périodes durant lesquels une stratégie est appliquée en un lieu.
     * Get the appliedPeriodVOs Association
     * This accessor method returns a reference to the live list,
     * not a snapshot. Therefore any modification you make to the
     * returned list will be present inside the object.
     * @return this.appliedPeriodVOs AppliedPeriodVO[]
     */
    public AppliedPeriodVO[] getAppliedPeriodVOs()
    {
        return this.appliedPeriodVOs;
    }

    /**
     * Sets the appliedPeriodVOs
     * @param value AppliedPeriodVO[]
     */
    public void setAppliedPeriodVOs(AppliedPeriodVO[] value)
    {
        this.appliedPeriodVOs = value;
    }

    /**
     * Définie les paramètres à mesurer dans un programme particulier.
     * Get the strategyVO Association
     * @return this.strategyVO StrategyVO
     */
    public StrategyVO getStrategyVO()
    {
        return this.strategyVO;
    }

    /**
     * Sets the strategyVO
     * @param value StrategyVO
     */
    public void setStrategyVO(StrategyVO value)
    {
        this.strategyVO = value;
    }

    /**
     * @param object to compare this object against
     * @return boolean if equal
     * @see Object#equals(Object)
     */
    @Override
    public boolean equals(final Object object)
    {
        if (object==null || object.getClass() != this.getClass())
        {
             return false;
        }
        // Check if the same object instance
        if (object==this)
        {
            return true;
        }
        AppliedStrategyVO rhs = (AppliedStrategyVO) object;
        return new EqualsBuilder()
            .append(this.getAppliedStratId(), rhs.getAppliedStratId())
            .append(this.getUpdateDt(), rhs.getUpdateDt())
            .append(this.getFreqCd(), rhs.getFreqCd())
            .append(this.getMonLocId(), rhs.getMonLocId())
            .append(this.getDepId(), rhs.getDepId())
            .append(this.getTaxonGroupId(), rhs.getTaxonGroupId())
            .append(this.getRefTaxonId(), rhs.getRefTaxonId())
            .append(this.getStratId(), rhs.getStratId())
            .append(this.getPmfmAppliedStrategyVOs(), rhs.getPmfmAppliedStrategyVOs())
            .append(this.getAppliedPeriodVOs(), rhs.getAppliedPeriodVOs())
            .append(this.getStrategyVO(), rhs.getStrategyVO())
            .isEquals();
    }

    /**
     * @param object to compare this object against
     * @return int if equal
     * @see Comparable#compareTo(Object)
     */
    public int compareTo(final AppliedStrategyVO object)
    {
        if (object==null)
        {
            return -1;
        }
        // Check if the same object instance
        if (object==this)
        {
            return 0;
        }
        return new CompareToBuilder()
            .append(this.getAppliedStratId(), object.getAppliedStratId())
            .append(this.getUpdateDt(), object.getUpdateDt())
            .append(this.getFreqCd(), object.getFreqCd())
            .append(this.getMonLocId(), object.getMonLocId())
            .append(this.getDepId(), object.getDepId())
            .append(this.getTaxonGroupId(), object.getTaxonGroupId())
            .append(this.getRefTaxonId(), object.getRefTaxonId())
            .append(this.getStratId(), object.getStratId())
            .append(this.getPmfmAppliedStrategyVOs(), object.getPmfmAppliedStrategyVOs())
            .append(this.getAppliedPeriodVOs(), object.getAppliedPeriodVOs())
            .append(this.getStrategyVO(), object.getStrategyVO())
            .toComparison();
    }

    /**
     * @return int hashCode value
     * @see Object#hashCode()
     */
    @Override
    public int hashCode()
    {
        return new HashCodeBuilder(1249046965, -82296885)
            .append(this.getAppliedStratId())
            .append(this.getUpdateDt())
            .append(this.getFreqCd())
            .append(this.getMonLocId())
            .append(this.getDepId())
            .append(this.getTaxonGroupId())
            .append(this.getRefTaxonId())
            .append(this.getStratId())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getPmfmAppliedStrategyVOs())
            //Commented out to avoid commons-lang-2.4 recursion StackOverflowError: https://issues.apache.org/jira/browse/LANG-456
            //.append(this.getAppliedPeriodVOs())
            .append(this.getStrategyVO())
            .toHashCode();
    }

    /**
     * @return String representation of object
     * @see Object#toString()
     */
    @Override
    public String toString()
    {
        return new ToStringBuilder(this)
            .append("appliedStratId", this.getAppliedStratId())
            .append("updateDt", this.getUpdateDt())
            .append("freqCd", this.getFreqCd())
            .append("monLocId", this.getMonLocId())
            .append("depId", this.getDepId())
            .append("taxonGroupId", this.getTaxonGroupId())
            .append("refTaxonId", this.getRefTaxonId())
            .append("stratId", this.getStratId())
            .append("pmfmAppliedStrategyVOs", this.getPmfmAppliedStrategyVOs())
            .append("appliedPeriodVOs", this.getAppliedPeriodVOs())
            .append("strategyVO", this.getStrategyVO())
            .toString();
    }

    /**
     * This is a convenient helper method which is able to detect whether or not two values are equal. Two values
     * are equal when they are both {@code null}, are arrays of the same length with equal elements or are
     * equal objects (this includes {@link java.util.Collection} and {@link java.util.Map} instances).
     *
     * <p/>Note that for array, collection or map instances the comparison runs one level deep.
     *
     * @param first the first object to compare, may be {@code null}
     * @param second the second object to compare, may be {@code null}
     * @return this method will return {@code true} in case both objects are equal as explained above;
     *      in all other cases this method will return {@code false}
     */
    protected static boolean equal(final Object first, final Object second)
    {
        final boolean equal;

        if (first == null)
        {
            equal = (second == null);
        }
        else if (first.getClass().isArray() && (second != null) && second.getClass().isArray())
        {
            equal = Arrays.equals((Object[])first, (Object[])second);
        }
        else // note that the following also covers java.util.Collection and java.util.Map
        {
            equal = first.equals(second);
        }

        return equal;
    }

    // AppliedStrategyVO value-object java merge-point
}